input1 = $1;
input2 = $2;
output = $3;

@kind = eset;

getta(input1);
getta(input2);

delete @object;		// Remove obsolete data by ldx
delete @address;	// Remove obsolete data by ldx

toSave = relnames;
for r in toSave { $r = $r; }

/////////////////////////////////////////////
///// Convert cSymbol
syms = source("prep.csym.qi");

delInst = syms o $INSTANCE;
addInst = syms X {"cFunction"};
$INSTANCE = $INSTANCE - delInst + addInst;

delete delInst;
delete addInst;

/////////////////////////////////////////////
///// Replace archive contents with real data 

// "Do" and "syms" are used in "prep.matcho"
Do = contain*;
syms = $INSTANCE . {"cSymbol", "cObject", "cFunction"};
match = source("prep.matcho.qi");

toDel = set;
allmatch = match;

reloc = (rng match o contain o $INSTANCE) . {"cObjectFile"}

for e in (dom match) {
	ao = {e};
	ob = ao . match;
	
	x_n = (ao . contain) o @name;
	
	if(ob in reloc) {
		y_n = ((ob . Do) ^ syms) o @name;
	} else {
		y_n = (ob . contain) o @name; 
	}
	
	smatch = x_n o inv y_n;
	allmatch = allmatch + smatch;
	
	tmp = ao . contain;
	if(#tmp > 0) toDel = toDel + (tmp . contain);
	
	tmp = tmp - (dom smatch);
	if(#tmp > 0) toDel = toDel + tmp;
	
	delete x_n;
	delete y_n;
	delete tmp;
}

if(#toDel > 0) delset(toDel);
if(#allmatch > 0) replaceid(allmatch);

syms = $INSTANCE . {"cSymbol", "cObject", "cFunction"};
contain = contain - (reloc o contain o syms);

delete match;
delete smatch;
delete allmatch;

/////////////////////////////////////////////

for r in toSave { $r = $r; }

putta(output, toSave);

